diff --git a/src/main/java/net/minecraft/core/item/tool/HoeToolItem.java b/src/main/java/net/minecraft/core/item/tool/HoeToolItem.java
index 26b47034b..6ac7533ee 100644
--- a/src/main/java/net/minecraft/core/item/tool/HoeToolItem.java
+++ b/src/main/java/net/minecraft/core/item/tool/HoeToolItem.java
@@ -2,6 +2,7 @@ package net.minecraft.core.item.tool;
 
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
@@ -10,8 +11,12 @@ import net.minecraft.core.item.Item;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.material.ToolMaterial;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
 //            Item, EnumToolMaterial, World, Block, 
@@ -33,8 +38,12 @@ public class HoeToolItem extends ToolItem
     }
 
     @Override
-    public boolean onUseItemOnBlock(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(ItemStack itemstack, Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
+        return till(itemstack, player, world, blockX, blockY, blockZ, side);
+    }
+
+    public boolean till(ItemStack itemstack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side) {
         int id = world.getBlockId(blockX, blockY, blockZ);
         int j1 = world.getBlockId(blockX, blockY + 1, blockZ);
         if(side != Side.BOTTOM && j1 == 0 && (id == Blocks.GRASS.id || id == Blocks.DIRT.id || id == Blocks.PATH_DIRT.id || id == Blocks.GRASS_RETRO.id || id == Blocks.MUD.id))
@@ -43,12 +52,12 @@ public class HoeToolItem extends ToolItem
             if(id == Blocks.MUD.id)
                 meta = 1;
             Block block = Blocks.FARMLAND_DIRT;
-            world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Blocks.DIRT, EnumBlockSoundEffectType.MINE);
+            world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Blocks.DIRT, EnumBlockSoundEffectType.MINE);
             if(!world.isClientSide) {
                 if(id == Blocks.GRASS.id || id == Blocks.GRASS_RETRO.id || id == Blocks.GRASS_SCORCHED.id) {
-                	if(world.rand.nextInt(5) == 0) {
-                		world.dropItem(blockX, blockY + 1, blockZ, new ItemStack(Items.SEEDS_WHEAT));
-                	}
+                    if(world.rand.nextInt(5) == 0) {
+                        world.dropItem(blockX, blockY + 1, blockZ, new ItemStack(Items.SEEDS_WHEAT));
+                    }
                 }
             }
             if(world.isClientSide)
@@ -57,7 +66,7 @@ public class HoeToolItem extends ToolItem
             } else
             {
                 world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, block.id, meta);
-                itemstack.damageItem(1, entityplayer);
+                itemstack.damageItem(1, player);
                 return true;
             }
         } else
@@ -65,7 +74,12 @@ public class HoeToolItem extends ToolItem
             return false;
         }
     }
-    
+
+    @Override
+    public void onUseByActivator(ItemStack itemStack, ActivatorBlockEntity activatorBlock, World world, Random random, int blockX, int blockY, int blockZ, double offX, double offY, double offZ, Direction direction) {
+        till(itemStack, null, world, blockX + direction.getOffsetX(), blockY + direction.getOffsetY(), blockZ + direction.getOffsetZ(), direction.getSide());
+    }
+
     @Override
     public boolean onBlockDestroyed(World world, ItemStack itemstack, int id, int x, int y, int z, Side side, Mob mob) {
     	if(mob != null && !mob.world.isClientSide) {
diff --git a/src/main/java/net/minecraft/core/item/tool/ShovelToolItem.java b/src/main/java/net/minecraft/core/item/tool/ShovelToolItem.java
index a19e2d050..902650fd2 100644
--- a/src/main/java/net/minecraft/core/item/tool/ShovelToolItem.java
+++ b/src/main/java/net/minecraft/core/item/tool/ShovelToolItem.java
@@ -2,14 +2,19 @@ package net.minecraft.core.item.tool;
 
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.material.ToolMaterial;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
 //            ToolItem, Block, EnumToolMaterial
@@ -28,14 +33,18 @@ public class ShovelToolItem extends ToolItem
     }
 
     @Override
-    public boolean onUseItemOnBlock(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(ItemStack itemstack, Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
-        int i1 = world.getBlockId(blockX, blockY, blockZ);
-        int j1 = world.getBlockId(blockX, blockY + 1, blockZ);
-        if(side != Side.BOTTOM && j1 == 0 && (i1 == Blocks.GRASS.id || i1 == Blocks.DIRT.id || i1 == Blocks.GRASS_RETRO.id || i1 == Blocks.FARMLAND_DIRT.id))
+        return shovelBlock(itemstack, player, world, blockX, blockY, blockZ, side);
+    }
+
+    public boolean shovelBlock(ItemStack itemstack, @Nullable Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side) {
+        int blockId = world.getBlockId(blockX, blockY, blockZ);
+        int blockAbove = world.getBlockId(blockX, blockY + 1, blockZ);
+        if(side != Side.BOTTOM && blockAbove == 0 && (blockId == Blocks.GRASS.id || blockId == Blocks.DIRT.id || blockId == Blocks.GRASS_RETRO.id || blockId == Blocks.FARMLAND_DIRT.id))
         {
             Block block = Blocks.PATH_DIRT;
-            world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Block.blocksList[i1], EnumBlockSoundEffectType.PLACE);
+            world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Block.blocksList[blockId], EnumBlockSoundEffectType.PLACE);
             if (!world.isClientSide) {
                 world.setBlockWithNotify(blockX, blockY, blockZ, block.id);
                 itemstack.damageItem(1, entityplayer);
@@ -44,4 +53,9 @@ public class ShovelToolItem extends ToolItem
         }
         return false;
     }
+
+    @Override
+    public void onUseByActivator(ItemStack itemStack, ActivatorBlockEntity activatorBlock, World world, Random random, int blockX, int blockY, int blockZ, double offX, double offY, double offZ, Direction direction) {
+        shovelBlock(itemStack, null, world, blockX + direction.getOffsetX(), blockY + direction.getOffsetY(), blockZ + direction.getOffsetZ(), direction.getSide());
+    }
 }
diff --git a/src/main/java/net/minecraft/core/item/tool/SwordToolItem.java b/src/main/java/net/minecraft/core/item/tool/SwordToolItem.java
index b71675049..c199b3f71 100644
--- a/src/main/java/net/minecraft/core/item/tool/SwordToolItem.java
+++ b/src/main/java/net/minecraft/core/item/tool/SwordToolItem.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.item.tool;
 
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.Mob;
@@ -8,9 +9,12 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.material.ToolMaterial;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
+import java.util.Random;
+
 // Referenced classes of package net.minecraft.src:
 //            Item, EnumToolMaterial, Block, ItemStack, 
 //            Mob, Entity
@@ -52,6 +56,18 @@ public class SwordToolItem extends Item
         return true;
     }
 
+    @Override
+    public void onUseByActivator(ItemStack itemStack, ActivatorBlockEntity activatorBlock, World world, Random random, int blockX, int blockY, int blockZ, double offX, double offY, double offZ, Direction direction) {
+        blockX += direction.getOffsetX();
+        blockY += direction.getOffsetY();
+        blockZ += direction.getOffsetZ();
+        Block b = world.getBlock(blockX, blockY, blockZ);
+        if (b == Blocks.PUMPKIN) {
+            world.setBlockAndMetadata(blockX, blockY, blockZ, Blocks.PUMPKIN_CARVED_IDLE.id, direction.getOpposite().getId());
+            itemStack.damageItem(1, null);
+        }
+    }
+
     @Override
     public int getDamageVsEntity(Entity entity)
     {
diff --git a/src/main/java/net/minecraft/core/net/packet/ContainerOpenPacket.java b/src/main/java/net/minecraft/core/net/packet/ContainerOpenPacket.java
index 2b585519f..88ea5573d 100644
--- a/src/main/java/net/minecraft/core/net/packet/ContainerOpenPacket.java
+++ b/src/main/java/net/minecraft/core/net/packet/ContainerOpenPacket.java
@@ -9,17 +9,33 @@ import java.io.*;
 
 public class ContainerOpenPacket extends Packet
 {
+    public static final int TYPE_GENERIC_CONTAINER = 0;
+    public static final int TYPE_CRAFTING = 1;
+    public static final int TYPE_FURNACE = 2;
+    public static final int TYPE_DISPENSER = 3;
+    public static final int TYPE_BLAST_FURNACE = 4;
+    public static final int TYPE_TROMMEL = 5;
+    public static final int TYPE_ACTIVATOR = 6;
+    public static final int TYPE_PAINTING = 7;
+
+    public int windowId;
+    public int inventoryType;
+    public String windowTitle;
+    public int slotsCount;
 
     public ContainerOpenPacket()
     {
     }
     
-    public ContainerOpenPacket(int i, int j, String s, int k)
+    public ContainerOpenPacket(int windowId, int inventoryType, String windowTitle, int slotCount)
     {
-        windowId = i;
-        inventoryType = j;
-        windowTitle = s;
-        slotsCount = k;
+        assert windowId <= Byte.MAX_VALUE : "Window Id > 127 won't serialize properly";
+        assert inventoryType <= Byte.MAX_VALUE : "Inventory Type > 127 won't serialize properly";
+        assert slotCount <= Byte.MAX_VALUE : "Slot Count > 127 won't serialize properly";
+        this.windowId = windowId;
+        this.inventoryType = inventoryType;
+        this.windowTitle = windowTitle;
+        slotsCount = slotCount;
     }
 
     @Override
@@ -53,9 +69,4 @@ public class ContainerOpenPacket extends Packet
     {
         return 3 + windowTitle.length();
     }
-
-    public int windowId;
-    public int inventoryType;
-    public String windowTitle;
-    public int slotsCount;
 }
diff --git a/src/main/java/net/minecraft/core/player/inventory/menu/AbstractContainerMenu.java b/src/main/java/net/minecraft/core/player/inventory/menu/AbstractContainerMenu.java
index 9501fb09a..0611efd83 100644
--- a/src/main/java/net/minecraft/core/player/inventory/menu/AbstractContainerMenu.java
+++ b/src/main/java/net/minecraft/core/player/inventory/menu/AbstractContainerMenu.java
@@ -15,6 +15,7 @@ import net.minecraft.core.player.inventory.container.Inventory;
 import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.core.player.inventory.slot.ResultSlot;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
 
 public abstract class AbstractContainerMenu
@@ -90,10 +91,15 @@ public abstract class AbstractContainerMenu
 
 	}
 
-	public Slot getSlotFor(Container container, int i)
+	/**
+	 * @param container Inventory
+	 * @param index integer index of slot in container
+	 * @return Slot for index in current container, null otherwise
+	 */
+	public @Nullable Slot getSlotFor(Container container, int index)
 	{
 		for (Slot inventorySlot : slots) {
-            if (inventorySlot.isAt(container, i)) {
+            if (inventorySlot.isAt(container, index)) {
 				return inventorySlot;
 			}
 		}
diff --git a/src/main/java/net/minecraft/core/player/inventory/menu/ActivatorMenu.java b/src/main/java/net/minecraft/core/player/inventory/menu/ActivatorMenu.java
new file mode 100644
index 000000000..e12b597ff
--- /dev/null
+++ b/src/main/java/net/minecraft/core/player/inventory/menu/ActivatorMenu.java
@@ -0,0 +1,75 @@
+package net.minecraft.core.player.inventory.menu;
+
+import net.minecraft.core.InventoryAction;
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.player.inventory.container.Container;
+import net.minecraft.core.player.inventory.slot.Slot;
+
+import java.util.List;
+
+public class ActivatorMenu extends AbstractContainerMenu {
+
+	public ActivatorBlockEntity activator;
+
+	private final int activatorSlotsStart;
+	private final int inventorySlotsStart;
+	private final int hotbarSlotsStart;
+
+	public ActivatorMenu(Container container, ActivatorBlockEntity activator) {
+		this.activator = activator;
+		for (int i = 0; i < ActivatorBlockEntity.CONTAINER_SIZE; i++) {
+			addSlot(new Slot(activator, i, 8 + i * 18, 35));
+		}
+
+		for (int j = 0; j < 3; j++) {
+			for (int i1 = 0; i1 < 9; i1++) {
+				addSlot(new Slot(container, i1 + j * 9 + 9, 8 + i1 * 18, 84 + j * 18));
+			}
+		}
+
+		for (int k = 0; k < 9; k++) {
+			addSlot(new Slot(container, k, 8 + k * 18, 142));
+		}
+		
+		activatorSlotsStart = 0;
+		inventorySlotsStart = 9;
+		hotbarSlotsStart = 36;
+	}
+	
+	@Override
+	public boolean stillValid(Player entityplayer) {
+		return activator.stillValid(entityplayer);
+	}
+
+	@Override
+	public List<Integer> getMoveSlots(InventoryAction action, Slot slot, int target, Player player) {
+		if(slot.index >= activatorSlotsStart && slot.index < inventorySlotsStart) {
+			return getSlots(activatorSlotsStart, 9, false);
+		}
+		
+		if(action == InventoryAction.MOVE_ALL) {
+			if(slot.index >= inventorySlotsStart && slot.index < hotbarSlotsStart) {
+				return getSlots(inventorySlotsStart, 27, false);
+			}
+			if(slot.index >= hotbarSlotsStart) {
+				return getSlots(hotbarSlotsStart, 9, false);
+			}
+		}
+		if(action == InventoryAction.MOVE_SIMILAR) {
+			if(slot.index >= inventorySlotsStart) {
+				return getSlots(inventorySlotsStart, 36, false);
+			}
+		}
+		return null;
+	}
+
+	@Override
+	public List<Integer> getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
+		if(slot.index >= activatorSlotsStart && slot.index < inventorySlotsStart) {
+			return getSlots(inventorySlotsStart, 36, false);
+		}else {
+			return getSlots(activatorSlotsStart, 9, false);
+		}
+	}
+}
diff --git a/src/main/java/net/minecraft/core/world/LevelListener.java b/src/main/java/net/minecraft/core/world/LevelListener.java
index 2df368461..9cf700e2a 100644
--- a/src/main/java/net/minecraft/core/world/LevelListener.java
+++ b/src/main/java/net/minecraft/core/world/LevelListener.java
@@ -3,6 +3,7 @@ package net.minecraft.core.world;
 // Referenced classes of package net.minecraft.src:
 //            Entity, BlockEntity, Player
 
+import net.minecraft.client.render.RenderGlobal;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.block.entity.BlockEntity;
diff --git a/src/main/java/net/minecraft/core/world/SpawnerMobs.java b/src/main/java/net/minecraft/core/world/SpawnerMobs.java
index 8e2d7aa8a..378da74f8 100644
--- a/src/main/java/net/minecraft/core/world/SpawnerMobs.java
+++ b/src/main/java/net/minecraft/core/world/SpawnerMobs.java
@@ -297,7 +297,7 @@ public final class SpawnerMobs
 									entity.spawnInit();
 									world.entityJoinedWorld(entity);
 									player.wakeUpPlayer(true, false);
-									world.playSoundEffect(null, 2001, (int) player.x, (int) player.y - 1, (int) player.z, world.getBlockId((int) player.x, (int) player.y - 1, (int) player.z));
+									world.playBlockEvent(null, 2001, (int) player.x, (int) player.y - 1, (int) player.z, world.getBlockId((int) player.x, (int) player.y - 1, (int) player.z));
 									entity.playLivingSound();
 									spawnedEntity = true;
 									spawnedEntityForPlayer = true;
diff --git a/src/main/java/net/minecraft/core/world/World.java b/src/main/java/net/minecraft/core/world/World.java
index a15af5e56..9ff87705c 100644
--- a/src/main/java/net/minecraft/core/world/World.java
+++ b/src/main/java/net/minecraft/core/world/World.java
@@ -1171,7 +1171,7 @@ public class World implements WorldSource {
     }
 
     @Nullable
-    public HitResult checkBlockCollisionBetweenPoints(Vec3 start, Vec3 end, boolean shouldCollideWithFluids, boolean flag1)
+    public HitResult checkBlockCollisionBetweenPoints(Vec3 start, Vec3 end, boolean shouldCollideWithFluids, boolean ignoreNonColliderBlocks)
     {
         if(Double.isNaN(start.x) || Double.isNaN(start.y) || Double.isNaN(start.z))
         {
@@ -1190,7 +1190,7 @@ public class World implements WorldSource {
         int id = getBlockId(blockStartX, blockStartY, blockStartZ);
         int meta = getBlockMetadata(blockStartX, blockStartY, blockStartZ);
         Block block = Block.blocksList[id];
-        if((!flag1 || block == null || block.getCollisionBoundingBoxFromPool(this, blockStartX, blockStartY, blockStartZ) != null) && id > 0 && (block.canCollideCheck(meta, shouldCollideWithFluids)))
+        if((!ignoreNonColliderBlocks || block == null || block.getCollisionBoundingBoxFromPool(this, blockStartX, blockStartY, blockStartZ) != null) && id > 0 && (block.canCollideCheck(meta, shouldCollideWithFluids)))
         {
             HitResult movingobjectposition = block.collisionRayTrace(this, blockStartX, blockStartY, blockStartZ, start, end);
             if(movingobjectposition != null)
@@ -1326,7 +1326,7 @@ public class World implements WorldSource {
             int j2 = getBlockId(blockStartX, blockStartY, blockStartZ);
             int k2 = getBlockMetadata(blockStartX, blockStartY, blockStartZ);
             Block block1 = Block.blocksList[j2];
-            if((!flag1 || block1 == null || block1.getCollisionBoundingBoxFromPool(this, blockStartX, blockStartY, blockStartZ) != null) && j2 > 0 && block1.canCollideCheck(k2, shouldCollideWithFluids))
+            if((!ignoreNonColliderBlocks || block1 == null || block1.getCollisionBoundingBoxFromPool(this, blockStartX, blockStartY, blockStartZ) != null) && j2 > 0 && block1.canCollideCheck(k2, shouldCollideWithFluids))
             {
                 HitResult movingobjectposition1 = block1.collisionRayTrace(this, blockStartX, blockStartY, blockStartZ, start, end);
                 if(movingobjectposition1 != null)
@@ -1339,7 +1339,7 @@ public class World implements WorldSource {
         return null;
     }
     
-    public void playSoundAtEntity(Entity player, Entity entity, String soundPath, float volume, float pitch)
+    public void playSoundAtEntity(@Nullable Entity player, Entity entity, String soundPath, float volume, float pitch)
     {
         for (LevelListener listener : listeners)
         {
@@ -1348,7 +1348,7 @@ public class World implements WorldSource {
 
     }
     
-    public void playSoundEffect(Entity player, SoundCategory category, double x, double y, double z, String soundPath,
+    public void playSoundEffect(@Nullable Entity player, SoundCategory category, double x, double y, double z, String soundPath,
                                 float volume, float pitch)
     {
         for (LevelListener listener : listeners)
@@ -1357,7 +1357,7 @@ public class World implements WorldSource {
         }
     }
     
-    public void playBlockSoundEffect(Entity player, double x, double y, double z, Block block, EnumBlockSoundEffectType soundType)
+    public void playBlockSoundEffect(@Nullable Entity player, double x, double y, double z, Block block, EnumBlockSoundEffectType soundType)
     {
         if (block == null) return;
 
@@ -2226,7 +2226,7 @@ public class World implements WorldSource {
         z += side.getOffsetZ();
         if(getBlockId(x, y, z) == Blocks.FIRE.id)
         {
-            playSoundEffect(entityplayer, 1004, x, y, z, 0);
+            playBlockEvent(entityplayer, 1004, x, y, z, 0);
             setBlockWithNotify(x, y, z, 0);
         }
     }
@@ -3278,12 +3278,12 @@ public class World implements WorldSource {
         return savedDataStorage.getFreeMetadataFor(s);
     }
 
-    public void playSoundEffect(int id, int x, int y, int z, int data)
+    public void playBlockEvent(int id, int x, int y, int z, int data)
     {
-        playSoundEffect(null, id, x, y, z, data);
+        playBlockEvent(null, id, x, y, z, data);
     }
 
-    public void playSoundEffect(Player entityplayer, int id, int x, int y, int z, int data)
+    public void playBlockEvent(Player entityplayer, int id, int x, int y, int z, int data)
     {
         for (LevelListener listener : listeners) {
             listener.levelEvent(entityplayer, id, x, y, z, data);
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLake.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLake.java
index 9c351498c..47d50bed8 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLake.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLake.java
@@ -98,7 +98,7 @@ public class WorldFeatureLake extends WorldFeature
             {
                 for(int dy = 0; dy < 8; dy++)
                 {
-                    if(shouldPlaceLiquid[(dx * 16 + dz) * 8 + dy])
+                    if(shouldPlaceLiquid[(dx * 16 + dz) * 8 + dy] && world.getBlockId(x + dx, y + dy, z + dz) != Blocks.BEDROCK.id)
                     {
                         world.setBlockWithNotify(x + dx, y + dy, z + dz, dy < 4 ? liquidId : 0);
                     }
@@ -114,7 +114,7 @@ public class WorldFeatureLake extends WorldFeature
             {
                 for(int dy = 4; dy < 8; dy++)
                 {
-                    if(shouldPlaceLiquid[(dx * 16 + dz) * 8 + dy] && world.getBlockId(x + dx, (y + dy) - 1, z + dz) == Blocks.DIRT.id && world.getSavedLightValue(LightLayer.Sky, x + dx, y + dy, z + dz) > 0)
+                    if(shouldPlaceLiquid[(dx * 16 + dz) * 8 + dy] && world.getBlockId(x + dx, y + dy - 1, z + dz) != Blocks.BEDROCK.id && world.getBlockId(x + dx, (y + dy) - 1, z + dz) == Blocks.DIRT.id && world.getSavedLightValue(LightLayer.Sky, x + dx, y + dy, z + dz) > 0)
                     {
                         world.setBlock(x + dx, (y + dy) - 1, z + dz, Blocks.GRASS.id);
                     }
@@ -133,7 +133,7 @@ public class WorldFeatureLake extends WorldFeature
                     for(int dy = 0; dy < 8; dy++)
                     {
                         boolean flag1 = !shouldPlaceLiquid[(dx * 16 + dz) * 8 + dy] && (dx < 15 && shouldPlaceLiquid[((dx + 1) * 16 + dz) * 8 + dy] || dx > 0 && shouldPlaceLiquid[((dx - 1) * 16 + dz) * 8 + dy] || dz < 15 && shouldPlaceLiquid[(dx * 16 + (dz + 1)) * 8 + dy] || dz > 0 && shouldPlaceLiquid[(dx * 16 + (dz - 1)) * 8 + dy] || dy < 7 && shouldPlaceLiquid[(dx * 16 + dz) * 8 + (dy + 1)] || dy > 0 && shouldPlaceLiquid[(dx * 16 + dz) * 8 + (dy - 1)]);
-                        if(flag1 && (dy < 4 || random.nextInt(2) != 0) && world.getBlockMaterial(x + dx, y + dy, z + dz).isSolid())
+                        if(flag1 && (dy < 4 || random.nextInt(2) != 0) && world.getBlockId(x + dx, y + dy, z + dz) != Blocks.BEDROCK.id && world.getBlockMaterial(x + dx, y + dy, z + dz).isSolid())
                         {
                             world.setBlock(x + dx, y + dy, z + dz, world.getWorldType().getFillerBlockId());
                         }
diff --git a/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java b/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
index caf11602c..09baaa878 100644
--- a/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
+++ b/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
@@ -143,6 +143,17 @@ class WorkbenchGenerator {
             .addInput('R', Items.DUST_REDSTONE)
             .create("dispenser", Blocks.DISPENSER_COBBLE_STONE.getDefaultStack());
 
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "#S#",
+                "#N#",
+                "#R#")
+            .addInput('#', Blocks.COBBLE_NETHERRACK)
+            .addInput('S', Blocks.SOULSAND)
+            .addInput('N', Items.NETHERCOAL)
+            .addInput('R', Items.DUST_REDSTONE)
+            .create("activator", Blocks.ACTIVATOR_COBBLE_NETHERRACK.getDefaultStack());
+
         RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
                 "###",
diff --git a/src/main/java/net/minecraft/server/entity/player/ServerPlayer.java b/src/main/java/net/minecraft/server/entity/player/ServerPlayer.java
index c05fb0ac7..4e6f1520d 100644
--- a/src/main/java/net/minecraft/server/entity/player/ServerPlayer.java
+++ b/src/main/java/net/minecraft/server/entity/player/ServerPlayer.java
@@ -185,7 +185,7 @@ public class ServerPlayer extends Player implements ContainerListener {
     @Override
 	public float getHeadHeight()
     {
-        return 1.62F;
+        return getHeightOffset(); // since server player heights and y values aren't synced, this is correct for server but not the client
     }
 
     @Override
@@ -490,13 +490,13 @@ public class ServerPlayer extends Player implements ContainerListener {
     }
 
     @Override
-	protected void checkFallDamage(double d, boolean flag)
+	protected void checkFallDamage(double yd, boolean onGround)
     {
     }
 
-    public void handleFalling(double d, boolean flag)
+    public void handleFalling(double dy, boolean onGround)
     {
-        super.checkFallDamage(d, flag);
+        super.checkFallDamage(dy, onGround);
     }
 
     private void getNextWindowId()
@@ -508,7 +508,7 @@ public class ServerPlayer extends Player implements ContainerListener {
 	public void displayWorkbenchScreen(int x, int y, int z)
     {
         getNextWindowId();
-        playerNetServerHandler.sendPacket(new ContainerOpenPacket(currentWindowId, 1, "Crafting", 9));
+        playerNetServerHandler.sendPacket(new ContainerOpenPacket(currentWindowId, ContainerOpenPacket.TYPE_CRAFTING, "Crafting", 9));
         craftingInventory = new CraftingMenu(inventory, world, x, y, z);
         craftingInventory.containerId = currentWindowId;
         craftingInventory.addSlotListener(this);
@@ -517,15 +517,15 @@ public class ServerPlayer extends Player implements ContainerListener {
     @Override
     public void displayPaintingPickerScreen()
     {
-        playerNetServerHandler.sendPacket(new ContainerOpenPacket(currentWindowId, 7, "Painting", 0));
+        playerNetServerHandler.sendPacket(new ContainerOpenPacket(currentWindowId, ContainerOpenPacket.TYPE_PAINTING, "Painting", 0));
     }
 
     @Override
 	public void displayContainerScreen(Container container)
     {
         getNextWindowId();
-        ServerPacketHandler.LOGGER.info((new StringBuilder()).append(username).append(" interacted with chest at (").append(x).append(", ").append(y).append(", ").append(z).append(")").toString());
-        playerNetServerHandler.sendPacket(new ContainerOpenPacket(currentWindowId, 0, container.getName(), container.getContainerSize()));
+        ServerPacketHandler.LOGGER.info("{} interacted with chest at ({}, {}, {})", username, x, y, z);
+        playerNetServerHandler.sendPacket(new ContainerOpenPacket(currentWindowId, ContainerOpenPacket.TYPE_GENERIC_CONTAINER, container.getName(), container.getContainerSize()));
         craftingInventory = new ContainerMenu(inventory, container);
         craftingInventory.containerId = currentWindowId;
         craftingInventory.addSlotListener(this);
@@ -537,11 +537,11 @@ public class ServerPlayer extends Player implements ContainerListener {
         getNextWindowId();
         if (blockEntity instanceof BlastFurnaceBlockEntity)
         {
-            playerNetServerHandler.sendPacket(new ContainerOpenPacket(currentWindowId, 4, blockEntity.getName(), blockEntity.getContainerSize()));
+            playerNetServerHandler.sendPacket(new ContainerOpenPacket(currentWindowId, ContainerOpenPacket.TYPE_BLAST_FURNACE, blockEntity.getName(), blockEntity.getContainerSize()));
         }
         else
         {
-            playerNetServerHandler.sendPacket(new ContainerOpenPacket(currentWindowId, 2, blockEntity.getName(), blockEntity.getContainerSize()));
+            playerNetServerHandler.sendPacket(new ContainerOpenPacket(currentWindowId, ContainerOpenPacket.TYPE_FURNACE, blockEntity.getName(), blockEntity.getContainerSize()));
         }
 
         craftingInventory = new FurnaceMenu(inventory, blockEntity);
@@ -553,17 +553,28 @@ public class ServerPlayer extends Player implements ContainerListener {
 	public void displayDispenserScreen(DispenserBlockEntity blockEntity)
     {
         getNextWindowId();
-        playerNetServerHandler.sendPacket(new ContainerOpenPacket(currentWindowId, 3, blockEntity.getName(), blockEntity.getContainerSize()));
+        playerNetServerHandler.sendPacket(new ContainerOpenPacket(currentWindowId, ContainerOpenPacket.TYPE_DISPENSER, blockEntity.getName(), blockEntity.getContainerSize()));
         craftingInventory = new TrapMenu(inventory, blockEntity);
         craftingInventory.containerId = currentWindowId;
         craftingInventory.addSlotListener(this);
     }
 
+    @Override
+    public void displayActivatorScreen(ActivatorBlockEntity blockEntity)
+    {
+        getNextWindowId();
+        playerNetServerHandler.sendPacket(new ContainerOpenPacket(currentWindowId, ContainerOpenPacket.TYPE_ACTIVATOR, blockEntity.getName(), blockEntity.getContainerSize()));
+        craftingInventory = new ActivatorMenu(inventory, blockEntity);
+        craftingInventory.containerId = currentWindowId;
+        craftingInventory.addSlotListener(this);
+    }
+
+
     @Override
 	public void displayTrommelScreen(TrommelBlockEntity blockEntity)
     {
         getNextWindowId();
-        playerNetServerHandler.sendPacket(new ContainerOpenPacket(currentWindowId, 5, blockEntity.getName(), blockEntity.getContainerSize()));
+        playerNetServerHandler.sendPacket(new ContainerOpenPacket(currentWindowId, ContainerOpenPacket.TYPE_TROMMEL, blockEntity.getName(), blockEntity.getContainerSize()));
         craftingInventory = new TrommelMenu(inventory, blockEntity);
         craftingInventory.containerId = currentWindowId;
         craftingInventory.addSlotListener(this);
